/*  Project LP5100
    Siemens Communications Ltd
    Copyright  1994. All Rights Reserved.

    SUBSYSTEM:    Application
    FILE:         md5_if.c
    AUTHOR:	      Pete Frost


    OVERVIEW
    ========
    Implementation file for	a wrapper interface to the MD5 algorithm	
*/
#include <string.h>
#include <stdio.h>
#include "md5.h"
#include "md5_if.h"


/*This routine wraps the MD5 message digest algoritm. An input buffer is supplied with 
the message to digest. The length of this buffer must be <= MD5_MAX_INBUF_LEN the result is
placed in a user supplied output buffer of length MD5_OUTBUF_LEN*.
This wrapper is optimised for single buffer conversion for multiple buffers use the MD5 interface
directly*/
void MD5Convert(unsigned char *pInbuf,unsigned int inLength,unsigned char *pOutbuf)
{
	/*Create an MD5 context*/
	MD5_CTX md5CTX;

	/*Initialise the MD5 context*/
	MD5Init(&md5CTX);

	/*Update the MD5 context*/
	MD5Update(&md5CTX,pInbuf,inLength);

	/*Complete the transformation*/
	MD5Final(&md5CTX);

	/*Return the result to the caller*/
	memcpy(pOutbuf,md5CTX.digest,MD5_OUTBUF_LEN);	
}

void MD5AsciiTransform(unsigned char * MD5_rawbuf,unsigned char *MD5AsciiFormBuf)
{
	char tempBuffer[10];
	char convertBuf[MD5_ASCII_BUF_LEN+1];
	int i;

	convertBuf[0] = '\0';
	for (i = 0; i < MD5_OUTBUF_LEN; i++)
	{
		sprintf(tempBuffer,"%02x",MD5_rawbuf[i]);
		strcat(convertBuf,tempBuffer);
	}
	memcpy(MD5AsciiFormBuf,convertBuf,MD5_ASCII_BUF_LEN);
}

